program actualizaInven;

uses
  Forms,
  shellapi, inifiles, SysUtils, windows;

{$R *.res}

//lee un valor string de un fichero INI
function leCadINI (clave, cadena : string; defecto : String) : String;
begin
  with tinifile.create (ExtractFilePath (Application.ExeName) +'invencliente.INI') do
  try
    result := ReadString (clave, cadena, defecto);
  finally
    free;
  end;
end;




//lee un valor booleano de un fichero INI
function leBoolINI (clave, cadena : string; defecto : boolean) : boolean;
begin
  with tinifile.create (ExtractFilePath (Application.ExeName) + 'invencliente.INI') do
  try
    result := readbool (clave, cadena, defecto);
  finally
    free;
  end;
end;

var
  carpetaActualizacion : string;
  resultado : LongBool;
begin
  Application.Initialize;
  Application.Title := 'AjpdSoft Actualizacin Inventario Cliente';
  Application.Run;

  //esperamos 2 segundos para que la invencliente.exe se haya cerrado
  Sleep(2000);

  //comprobamos si est activada la opcin de actualizar
  if leBoolINI('Configuracin', 'Actualizar aplicacin al iniciar', false) = true then
  begin
    carpetaActualizacion := leCadINI('Configuracin', 'Carpeta de actualizacin', '');
    if FileExists(carpetaActualizacion) then
      resultado := copyfile (pchar(carpetaActualizacion),
          pchar(ExtractFilePath (Application.ExeName) + 'invencliente.exe'), false);
    Application.ProcessMessages;

    //esperamos 2 segundos para garantizar que invencliente.exe se ha copiado
    Sleep(2000);

    //volvemos a ejecutar la aplicacin "invencliente.exe"
    ShellExecute(Application.Handle, Nil,
        PChar(ExtractFilePath (Application.ExeName) + 'invencliente.exe'),
        Nil, Nil, 1);
  end;
  Application.Terminate;
  Halt;
end.
