unit UnidadMenuPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ScktComp, StdCtrls, shellapi, ComCtrls, registry, ImgList,
  TrayIcon, Menus, ExtCtrls;

type
  TformUnidadPrincipal = class(TForm)
    sSocket: TServerSocket;
    Label1: TLabel;
    txtPuerto: TEdit;
    bEscuchar: TButton;
    txtRuta: TEdit;
    Label2: TLabel;
    be: TStatusBar;
    ImageList1: TImageList;
    opNotificarActividad: TCheckBox;
    bRuta: TButton;
    opEscuchar: TCheckBox;
    opIniciarMinimizado: TCheckBox;
    iMinimizar: TTrayIcon;
    opIniciarOculto: TCheckBox;
    opIniciarWindows: TCheckBox;
    Label4: TLabel;
    txtCarpetaActualizacion: TEdit;
    Button1: TButton;
    opActualizarAuto: TCheckBox;
    bMinimizar: TButton;
    bCerrar: TButton;
    PopupMenu1: TPopupMenu;
    Mostrar1: TMenuItem;
    Panel1: TPanel;
    Label3: TLabel;
    Label5: TLabel;
    LWEB: TLabel;
    Image1: TImage;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure sSocketClientRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure bEscucharClick(Sender: TObject);
    procedure sSocketClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure sSocketClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure sSocketClientError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure sSocketClientWrite(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure bCerrarClick(Sender: TObject);
    procedure Mostrar1Click(Sender: TObject);
    procedure bMinimizarClick(Sender: TObject);
    procedure iMinimizarDblClick(Sender: TObject);
    procedure guardarConfiguracion ();
    procedure LWEBClick(Sender: TObject);
    procedure capturarPantallaClick(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formUnidadPrincipal: TformUnidadPrincipal;

implementation

uses UnidadProcedimientos;

{$R *.dfm}

procedure TformUnidadPrincipal.capturarPantallaClick(Sender: TObject);
var
  handlePantalla : hdc;
begin
  //ocultamos el formulario de la
  //aplicacin para que no aparezca
  hide;

  image1.autosize := false;
  sleep(1000); //esperamos un segundo

  image1.picture := nil; //eliminamos el contenido del image1 actual

  //establecemos el tamao de image1 al tamao de la resolucin de la pantalla
  image1.SetBounds(0, 0, screen.width, screen.height);

  handlePantalla := GetDesktopWindow; //obtenemos el handle de la pantalla

  //copiamos la captura a image1, mediante la funcin BitBlt
  BitBlt(image1.Canvas.handle, 0, 0, screen.width, screen.Height,
    getdc(handlePantalla), 0, 0, srcCopy);

  ReleaseDC(0, handlePantalla);  //liberamos el objeto

  show;
  image1.autosize := true;
  Image1.Picture.SaveToFile(ExtractFilePath(Application.ExeName) + 'captura.bmp');
end;

function versionFichero (const FileName: TFileName;
    var Major, Minor, Release, Build : word): boolean;
var
  size, len: longword;
  handle: THandle;
  buffer: pchar;
  pinfo: ^VS_FIXEDFILEINFO;
begin
  Result := False;
  size := GetFileVersionInfoSize(Pointer(FileName), handle);
  if size > 0 then begin
    GetMem(buffer, size);
    if GetFileVersionInfo(Pointer(FileName), 0, size, buffer)
    then
      if VerQueryValue(buffer, '\', pointer(pinfo), len) then begin
        Major   := HiWord(pinfo.dwFileVersionMS);
        Minor   := LoWord(pinfo.dwFileVersionMS);
        Release := HiWord(pinfo.dwFileVersionLS);
        Build   := LoWord(pinfo.dwFileVersionLS);
        Result  := True;
      end;
    FreeMem(buffer);
  end;
end;


procedure TformUnidadPrincipal.guardarConfiguracion ();
var
  reg : TRegistry;
begin
  esCadINI('Configuracin', 'Puerto', txtPuerto.Text);
  esBoolINI('Configuracin', 'Escuchar al iniciar',
      opEscuchar.Checked);
  esCadINI('Configuracin', 'Ejecutable inventario',
      txtRuta.Text);
  esCadINI('Configuracin', 'Carpeta de actualizacin',
      txtCarpetaActualizacion.Text);
  esBoolINI('Configuracin', 'Actualizar aplicacin al iniciar',
      opActualizarAuto.Checked);
  esBoolINI('Configuracin', 'Notificar actividad',
      opNotificarActividad.Checked);
  esBoolINI('Configuracin', 'Iniciar minimizado',
      opIniciarMinimizado.Checked);
  esBoolINI('Configuracin', 'Iniciar oculto',
      opIniciarOculto.Checked);
  esBoolINI('Configuracin', 'Ejecutar al iniciar Windows',
      opIniciarWindows.Checked);

  if opIniciarWindows.Checked then
  begin
    Reg := TRegistry.Create(KEY_WRITE);
    try
      Reg.RootKey := HKEY_LOCAL_MACHINE;
      if Reg.OpenKey('\Software\Microsoft\Windows\CurrentVersion\Run', True) then
      begin
        try
          Reg.WriteString('Cliente de Inventario', ExtractFilePath(Application.ExeName) + ExtractFileName(Application.ExeName));
        except
          Reg.CloseKey;
          raise;
        end;
      end
      else
        be.Panels[0].Text := 'Error al guardar valor en regedit';
      Reg.CloseKey;
    finally
      Reg.Free;
    end;
  end
  else
  begin
    {TODO : eliminar clave del regedit si no existe}
  end;
end;

procedure TformUnidadPrincipal.FormCreate(Sender: TObject);
var
  mayor, menor, release, build : WORD;
  mayor_a, menor_a, release_a, build_a : WORD;
begin
  txtPuerto.Text := leCadINI('Configuracin', 'Puerto', '9998');
  opEscuchar.Checked := leBoolINI('Configuracin', 'Escuchar al iniciar', false);
  txtRuta.Text := leCadINI('Configuracin', 'Ejecutable inventario', '');
  txtCarpetaActualizacion.Text := leCadINI('Configuracin', 'Carpeta de actualizacin', '');
  opActualizarAuto.Checked := leBoolINI('Configuracin', 'Actualizar aplicacin al iniciar', false);
  opNotificarActividad.Checked := leBoolINI('Configuracin', 'Notificar actividad', false);
  opIniciarMinimizado.Checked := leBoolINI('Configuracin', 'Iniciar minimizado', false);
  opIniciarOculto.Checked := leBoolINI('Configuracin', 'Iniciar oculto', false);
  opIniciarWindows.Checked := leBoolINI('Configuracin', 'Ejecutar al iniciar Windows', false);

  //si est marcada la actualizacin automtica, abrimos la aplicacin
  //actualizarInven.exe y cerramos esta para poder actualizarla
  if not (HiWord(GetKeyState(VK_SHIFT)) <> 0) then
  begin
    if opActualizarAuto.Checked then
    begin
      //comprobamos la versin del fichero a actualizar
      versionFichero (txtCarpetaActualizacion.Text, mayor, menor, release, build);

      //comprobamos la versin del fichero actual
      versionFichero (txtCarpetaActualizacion.Text, mayor_a, menor_a, release_a, build_a);

      //comprobamos las versiones
      if (mayor > mayor_a) or (menor > menor_a) or (release > release_a) or (build > build_a) then
      begin
        ShellExecute(formUnidadPrincipal.Handle, nil,
            PChar('actualizaInven.exe'), '', '', SW_SHOWNORMAL);
        Application.Terminate;
        close;
        exit;
      end;
    end;
  end;

  if txtRuta.Text = '' then
    txtRuta.Text := ExtractFilePath(Application.ExeName) + 'inventario.exe';
  if (txtPuerto.Text <> '')
      and opEscuchar.Checked then
  begin
    bEscucharClick(Self);
  end;

  if not (HiWord(GetKeyState(VK_SHIFT)) <> 0) then
  begin
    if opIniciarOculto.Checked then
    begin
      Hide;
      Application.ShowMainForm := False;
    end
    else
      if opIniciarMinimizado.Checked then
        bMinimizarClick(Self);
  end;
end;

procedure TformUnidadPrincipal.FormDestroy(Sender: TObject);
begin
  sSocket.Active := False;
end;

procedure TformUnidadPrincipal.sSocketClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
var
  mensaje : string;
  SEInfo: TShellExecuteInfo;
  ExitCode: DWORD;
  ejecutarFichero: string;
begin
  be.Panels[0].Text := 'Datos recibidos';
  be.Panels[1].Text := 'Conectado';  
  be.Refresh;
  //Lee el mensaje enviado
  mensaje := Socket.ReceiveText;

  //Inventariar equipo
  if mensaje = 'OBTENERINFORMACION' then
  begin
    BE.Panels[1].Text := 'Inventariado';  
    ejecutarFichero := txtRuta.Text;
    FillChar(SEInfo, SizeOf(SEInfo), 0);
    SEInfo.cbSize := SizeOf(TShellExecuteInfo);
    with SEInfo do
    begin
      fMask := SEE_MASK_NOCLOSEPROCESS;
      Wnd := Application.Handle;
      lpFile := PChar(ejecutarFichero);
      nShow := SW_SHOWNORMAL;
    end;
    if ShellExecuteEx(@SEInfo) then
    begin
      repeat
        Application.ProcessMessages;
        GetExitCodeProcess(SEInfo.hProcess, ExitCode);
      until (ExitCode <> STILL_ACTIVE) or Application.Terminated;
      Socket.SendText('DATOSOBTENIDOS');
    end
    else
      Socket.SendText('ERRORDATOSOBTENIDOS');
  end;

  //Comprobar conexin
  if mensaje = 'COMPROBARCONEXION' then
  begin
    Socket.SendText('COMPROBACIONCORRECTA');
  end;

  //Capturar pantalla
  if mensaje = 'CAPTURARPANTALLA' then
  begin
    be.Panels[1].Text := 'Cap. Pantalla';
    capturarPantallaClick(Self);
  end;

  //Tareas de mantenimiento
  if mensaje = 'TAREASMANTENIMIENTO' then
  begin
    be.Panels[1].Text := 'Tareas mnto.';
  end;

end;

procedure TformUnidadPrincipal.bEscucharClick(Sender: TObject);
begin
  if sSocket.Active then
  begin
    sSocket.Active := false;
    bEscuchar.Caption := 'Escuchar ahora';
  end
  else
  begin
    if txtPuerto.Text <> '' then
    begin
      sSocket.Port := StrToInt(txtPuerto.Text);
      sSocket.Active := true;
      bEscuchar.Caption := 'Detener escucha';
    end
    else
      be.Panels[0].Text := 'Debe indicar el puerto para la conexin';
  end;
end;

procedure TformUnidadPrincipal.sSocketClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  be.Panels[0].Text := 'Conectado a ' + sSocket.Socket.LocalHost;
  be.Panels[1].Text := 'Conectado';
  be.Refresh;
  bEscuchar.Caption := 'Detener escucha';  
end;

procedure TformUnidadPrincipal.sSocketClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  be.Panels[0].Text := 'Desconectado';
  be.Panels[1].Text := 'Desconectado';
  be.Refresh;
  bEscuchar.Caption := 'Escuchar ahora';  
end;

procedure TformUnidadPrincipal.sSocketClientError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
  be.Panels[0].Text := 'Error en la conexin';
  be.Panels[1].Text := 'Desconectado';
  be.Refresh;
  bEscuchar.Caption := 'Escuchar ahora';
end;

procedure TformUnidadPrincipal.sSocketClientWrite(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  be.Panels[0].Text := 'Datos enviados...';
  be.Panels[1].Text := 'Conectado';  
  be.Refresh;
end;

procedure TformUnidadPrincipal.bCerrarClick(Sender: TObject);
begin
  guardarConfiguracion ();

  close;
end;

procedure TformUnidadPrincipal.Mostrar1Click(Sender: TObject);
begin
  show;
  WindowState := wsNormal;
  iMinimizar.Hide;
end;

procedure TformUnidadPrincipal.bMinimizarClick(Sender: TObject);
begin
  Hide;
  Application.ShowMainForm := False;
  iMinimizar.Hint := Application.Title;
  iMinimizar.Show;
end;

procedure TformUnidadPrincipal.iMinimizarDblClick(Sender: TObject);
begin
  Mostrar1Click (Self);  
end;

procedure TformUnidadPrincipal.LWEBClick(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar('http://www.ajpdsoft.com'),
      Nil, Nil, SW_SHOWNORMAL);
end;

end.
