unit UnidadConsultaIPs;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, dxExEdtr, DB, KDaoTable, dxCntner, dxTL, dxDBCtrl, dxDBGrid;

type
  TformConsultaIP = class(TForm)
    tabla: TdxDBGrid;
    tSQL: TKADaoTable;
    dSQL: TDataSource;
    tSQLRedNombrePC: TStringField;
    tSQLUsuarioRed: TStringField;
    tSQLUsuarioNombre: TStringField;
    tSQLtarjetasTCPIPNombre: TStringField;
    tSQLIP: TStringField;
    tSQLIPsTarjetasRedNombre: TStringField;
    tablaUsuarioRed: TdxDBGridMaskColumn;
    tablaUsuarioNombre: TdxDBGridMaskColumn;
    tablatarjetasTCPIPNombre: TdxDBGridMaskColumn;
    tablaIP: TdxDBGridMaskColumn;
    tablaIPsTarjetasRedNombre: TdxDBGridMaskColumn;
    tablaRedNombrePC: TdxDBGridMaskColumn;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure tablaDblClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formConsultaIP: TformConsultaIP;

implementation

uses UnidadInformacionDetallada;

{$R *.dfm}

procedure TformConsultaIP.FormCreate(Sender: TObject);
begin
  tSQL.Close;
  tsql.SQL.Clear;
  tSQL.SQL.Add('SELECT Puesto.RedNombrePC, Puesto.UsuarioRed, Usuario.Nombre, ');
  tSQL.SQL.Add('    tarjetasTCPIP.Nombre, IPsTarjetasRed.IP, IPsTarjetasRed.Nombre');
  tSQL.SQL.Add('FROM ((Usuario INNER JOIN Puesto ON');
  tSQL.SQL.Add('      Usuario.UsuarioRed = Puesto.UsuarioRed)');
  tSQL.SQL.Add('    INNER JOIN tarjetasTCPIP ON');
  tSQL.SQL.Add('      Puesto.RedNombrePC = tarjetasTCPIP.RedNombrePC)');
  tSQL.SQL.Add('    INNER JOIN IPsTarjetasRed ON tarjetasTCPIP.ID = IPsTarjetasRed.IDTarjetaRed');
  tSQL.Open;
end;

procedure TformConsultaIP.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TformConsultaIP.tablaDblClick(Sender: TObject);
var
  formulario : TformInformacionDetallada;
begin
  if (tSQL.FieldByName ('RedNombrePC').Value = null) or (tSQL.FieldByName ('RedNombrePC').Value = '') then
    MessageDlg('El elemento seleccionado no tiene Identificativo.', mtInformation, [mbok], 0)
  else
  begin
    formulario := TformInformacionDetallada.Create(Application);
    try
      formulario.llenarTablasDetalle(tSQL.FieldByName ('RedNombrePC').Value);
      formulario.ShowModal;
    finally
      formulario.Free;
    end;
  end;
end;

end.
