unit UnidadMenuPrincipal;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  SvcMgr, Dialogs, inifiles, ExtCtrls;

type
  TAjpdSoftInventarioCliente = class(TService)
    temporizador: TTimer;
    procedure temporizadorTimer(Sender: TObject);
    procedure ServiceExecute(Sender: TService);
  private
    { Private declarations }
  public
    function GetServiceController: TServiceController; override;
    { Public declarations }
  end;

var
  AjpdSoftInventarioCliente: TAjpdSoftInventarioCliente;

implementation

{$R *.DFM}

function leCadINI (clave, cadena : string; defecto : string) : string;
begin
  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    result := readString (clave, cadena, defecto);
  finally
    free;
  end;
end;

procedure ServiceController(CtrlCode: DWord); stdcall;
begin
  AjpdSoftInventarioCliente.Controller(CtrlCode);
end;

function TAjpdSoftInventarioCliente.GetServiceController: TServiceController;
begin
  Result := ServiceController;
end;

procedure TAjpdSoftInventarioCliente.temporizadorTimer(Sender: TObject);
var
  rutaInvenClienteRed, rutaInvenClienteLocal : string;
begin
  rutaInvenClienteRed := leCadINI('Configuracin',
      'Ruta inventario cliente red', '');
  rutaInvenClienteLocal := leCadINI('Configuracin',
      'Ruta inventario cliente local', '');
  if not DirectoryExists(ExtractFilePath (rutaInvenClienteLocal)) then
    mkdir (ExtractFilePath (rutaInvenClienteLocal));
  CopyFile(pchar(rutaInvenClienteRed),
      pchar(rutaInvenClienteLocal), false);
  //comprobar si el inventario cliente ya est ejecutado, en caso contrario, ejecutar

end;

procedure TAjpdSoftInventarioCliente.ServiceExecute(Sender: TService);
begin
  temporizador.Enabled := true;
  while not Self.Terminated do
    ServiceThread.ProcessRequests(True);
end;

end.
