unit UnidadMenuPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ScktComp, ExtCtrls, StdCtrls;

type
  TformMenuPrincipal = class(TForm)
    cSocket: TClientSocket;
    txtEstado: TMemo;
    Splitter1: TSplitter;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    txtPC: TComboBox;
    txtPuerto: TEdit;
    txtAccion: TComboBox;
    bConectar: TButton;
    bAccion: TButton;
    procedure cSocketError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure cSocketConnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure cSocketDisconnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure cSocketRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure bConectarClick(Sender: TObject);
    procedure bAccionClick(Sender: TObject);
    procedure txtPuertoExit(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formMenuPrincipal: TformMenuPrincipal;

implementation

{$R *.dfm}

procedure TformMenuPrincipal.cSocketError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
var
    ErrorMsg : String;
Begin
    //cdigo de error
    Case ErrorCode Of
        10004 : ErrorMsg := 'Funcin de llamada interrumpida.';
        10013 : ErrorMsg := 'Permiso denegado.';
        10014 : ErrorMsg := 'Direccin incorrecta.';
        10022 : ErrorMsg := 'Argumentos no vlidos.';
        10024 : ErrorMsg := 'Trop de fichiers ouverts.';
        10035 : ErrorMsg := 'Resource temporarily unavailable.';
        10036 : ErrorMsg := 'Operation en cours.';
        10037 : ErrorMsg := 'Operation dj en cours.';
        10038 : ErrorMsg := 'Socket operation On non-socket.';
        10039 : ErrorMsg := 'Destination address required.';
        10040 : ErrorMsg := 'Message trop long.';
        10041 : ErrorMsg := 'Protocol wrong Type For socket.';
        10042 : ErrorMsg := 'Bad protocol option.';
        10043 : ErrorMsg := 'Protocol Not supported.';
        10044 : ErrorMsg := 'Socket Type Not supported.';
        10045 : ErrorMsg := 'Operation Not supported.';
        10046 : ErrorMsg := 'Protocol family Not supported.';
        10047 : ErrorMsg := 'Address family Not supported by protocol family.';
        10048 : ErrorMsg := 'Address already In use.';
        10049 : ErrorMsg := 'Cannot assign requested address.';
        10050 : ErrorMsg := 'Network Is down.';
        10051 : ErrorMsg := 'Network Is unreachable.';
        10052 : ErrorMsg := 'Network dropped connection On reset.';
        10053 : ErrorMsg := 'Un programa ha finalizado la conexin.';
        10054 : ErrorMsg := 'Connection reset by peer.';
        10055 : ErrorMsg := 'No hay suficiente espacio en la cach.';
        10056 : ErrorMsg := 'Ya est conectado.';
        10057 : ErrorMsg := 'No est conectado.';
        10058 : ErrorMsg := 'No se puede enviar despus de desconectar la sesin.';
        10060 : ErrorMsg := 'Se ha pasado el tiempo de conexin.';
        10061 : ErrorMsg := 'Conexin rechazada.';
        10064 : ErrorMsg := 'Host Is down.';
        10065 : ErrorMsg := 'No route To host.';
        10067 : ErrorMsg := 'Too many processes.';
        10091 : ErrorMsg := 'Network subsystem Is unavailable.';
        10092 : ErrorMsg := 'WINSOCK.DLL version Out Of range.';
        10093 : ErrorMsg := 'Successful WSAStartup Not yet performed.';
        10094 : ErrorMsg := 'Graceful shutdown In progress.';
        11001 : ErrorMsg := 'Host Not found.';
        11002 : ErrorMsg := 'Non-authoritative host Not found.';
        11003 : ErrorMsg := 'This Is a non-recoverable error.';
        11004 : ErrorMsg := 'Valid name, no data Record Of requested Type.';
    Else
        ErrorMsg := 'Error desconocido.';
    End;
    ErrorMsg := 'Error en conexin n' + IntToStr(ErrorCode) + ' : ' + ErrorMsg;
    ErrorCode := 0;
    Case ErrorEvent Of
        eeSend       : ErrorMsg := 'Escribiendo '       + ErrorMsg;
        eeReceive    : ErrorMsg := 'Leyendo '       + ErrorMsg;
        eeConnect    : ErrorMsg := 'Conectando '    + ErrorMsg;
        eeDisconnect : ErrorMsg := 'Desconectando ' + ErrorMsg;
        eeAccept     : ErrorMsg := 'Aceptando '     + ErrorMsg;
    Else
        ErrorMsg := 'Desconocido ' + ErrorMsg;
    End;
  txtEstado.Lines.Add('Error al conectar a ' + cSocket.Host);
  txtEstado.Lines.Add('Error: ' + ErrorMsg);
end;

procedure TformMenuPrincipal.cSocketConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  txtEstado.Lines.Add ('Conectado a ' + cSocket.Host);
end;

procedure TformMenuPrincipal.cSocketDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  txtEstado.Lines.Add ('Desconectado');
end;

procedure TformMenuPrincipal.cSocketRead(Sender: TObject;
  Socket: TCustomWinSocket);
var
  mensaje : string;
begin
  //segn la cadena devuelta por el cliente haremos la accin correspondiente
   mensaje := Socket.ReceiveText;
   //comprobacin de conexin
   if mensaje = 'COMPROBACIONCORRECTA' then
   begin
     txtEstado.Lines.Add('Conexin establecida con ' + cSocket.Host + ' correctamente.');
   end;
   if mensaje = 'DATOSOBTENIDOS' then
   begin
     txtEstado.Lines.Add('Los datos del PC ' + cSocket.Host + ' se han obtenido correctamente.');
   end;
   if mensaje = 'ERRORDATOSOBTENIDOS' then
   begin
     txtEstado.Lines.Add('Error al intentar obtener datos de ' + cSocket.Host);
   end;
end;

procedure TformMenuPrincipal.bConectarClick(Sender: TObject);
begin
  if txtPC.Text <> '' then
  begin
    cSocket.Active := false;
    cSocket.Host := txtPC.Text;
    cSocket.Port := StrToInt(txtPuerto.Text);
    cSocket.Active := true;
  end
  else
  begin
    MessageDlg('Debe indicar el nombre de red del equipo cliente ' +
        '(hostname) o la direccin IP.', mtWarning, [mbOK], 0);
    txtPC.SetFocus;
  end;
end;

procedure TformMenuPrincipal.bAccionClick(Sender: TObject);
begin
  if not cSocket.Active then
  begin
    MessageDlg('Debe conectarse al cliente pulsando el botn "Conectar".',
        mtWarning, [mbok], 0);
    bConectar.SetFocus;
  end
  else
  begin
    if txtAccion.Text <> '' then
    begin
      if txtAccion.Text = 'Comprobar conexin' then
      begin
        cSocket.Socket.SendText('COMPROBARCONEXION');
      end;
      if txtAccion.Text = 'Inventariar equipo' then
      begin
        cSocket.Socket.SendText('OBTENERINFORMACION');
      end;
      if txtAccion.Text = 'Capturar pantalla' then
      begin
        cSocket.Socket.SendText('CAPTURARPANTALLA');
      end;
      if txtAccion.Text = 'Realizar tareas de mantenimiento' then
      begin
        cSocket.Socket.SendText('TAREASMANTENIMIENTO');
        MessageDlg ('Esta opcin an no est disponible, perdonen las molestias.',
          mtInformation, [mbok], 0);
      end;
    end
    else
    begin
      MessageDlg('Debe indicar la accin a realizar en el equipo cliente.',
          mtWarning, [mbok], 0);
      txtAccion.SetFocus;
    end;
  end;
end;

procedure TformMenuPrincipal.txtPuertoExit(Sender: TObject);
begin
  bConectar.SetFocus;
end;

end.
