unit UnidadAplicacionesDatosSensibles;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, CheckLst, DB, KDaoTable, KDaoDataBase, ComCtrls;

type
  TformAplicacionesDatosSensibles = class(TForm)
    tTabla: TKADaoTable;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    lAplicaciones: TCheckListBox;
    Label1: TLabel;
    bSeleccionar: TButton;
    txtSeleccionadas: TEdit;
    bCancelar: TButton;
    bNuevo: TButton;
    txtNombre: TEdit;
    Label2: TLabel;
    txtVersion: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    txtCaracter: TComboBox;
    Memo1: TMemo;
    bMarcar: TButton;
    bDesmarcar: TButton;
    bInvertir: TButton;
    procedure bCancelarClick(Sender: TObject);
    procedure bSeleccionarClick(Sender: TObject);
    function obtenerSeleccionadas : string;
    procedure FormCreate(Sender: TObject);
    procedure lAplicacionesClickCheck(Sender: TObject);
    procedure bNuevoClick(Sender: TObject);
    procedure llenarLista ();
    procedure bMarcarClick(Sender: TObject);
    procedure bDesmarcarClick(Sender: TObject);
    procedure bInvertirClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formAplicacionesDatosSensibles: TformAplicacionesDatosSensibles;

implementation

uses UnidadMenuPrincipal;

{$R *.dfm}

procedure TformAplicacionesDatosSensibles.llenarLista ();
begin
  if formMenuPrincipal.conectarBD (false) then
  begin
    tTabla.Close;
    tTabla.SQL.Clear;
    tTabla.SQL.Add('SELECT nombre FROM AplicacionesDatosSensibles ORDER BY nombre');
    tTabla.Open;
    lAplicaciones.Clear;
    while not tTabla.Eof do
    begin
      lAplicaciones.Items.Add(tTabla.fieldbyname('nombre').Value);
      tTabla.Next;
    end;
    tTabla.Close;
  end
  else
    MessageDlg('Esta opcin no est disponible si no tiene conexin con ' +
        'la Base de datos.', mtInformation, [mbok], 0);
end;

function TformAplicacionesDatosSensibles.obtenerSeleccionadas () : string;
var
  i : integer;
  aplicaciones : string;
begin
  aplicaciones := '';
  for i := 0 to lAplicaciones.Count - 1 do
  begin
    if lAplicaciones.Checked [i] then
    begin
      if aplicaciones <> '' then
        aplicaciones := aplicaciones + ' || ' + lAplicaciones.Items[i]
      else
        aplicaciones := lAplicaciones.Items[i];
    end;
  end;
  result := aplicaciones;
end;

procedure TformAplicacionesDatosSensibles.bCancelarClick(Sender: TObject);
begin
  Close;
end;

procedure TformAplicacionesDatosSensibles.bSeleccionarClick(
  Sender: TObject);
begin
   vtAplicacionesSeleccionadas := obtenerSeleccionadas;
   Close;
end;

procedure TformAplicacionesDatosSensibles.FormCreate(Sender: TObject);
begin
  llenarLista ();
end;

procedure TformAplicacionesDatosSensibles.lAplicacionesClickCheck(
  Sender: TObject);
begin
  txtSeleccionadas.Text := obtenerSeleccionadas;
end;

procedure TformAplicacionesDatosSensibles.bNuevoClick(Sender: TObject);
var
  nombre : string;
begin
  nombre := txtNombre.Text;
  nombre := Trim(nombre);
  if nombre <> '' then
  begin
    tTabla.Close;
    tTabla.SQL.Clear;
    tTabla.TableName := 'AplicacionesDatosSensibles';
    tTabla.Open;
    if not tTabla.Locate('nombre', nombre, []) then
    begin
      tTabla.Insert;
      tTabla.FieldByName('nombre').Value := nombre;
      tTabla.FieldByName('version').Value := txtVersion.Text;
      tTabla.FieldByName('caracter').Value := txtCaracter.Text;      
      tTabla.Post;
      llenarLista;
      txtNombre.Text := '';
      txtVersion.Text := '';
      txtCaracter.itemindex := -1;
      MessageDlg('El programa se ha aadido correctamente.', mtInformation, [mbok], 0);
      txtNombre.SetFocus;
    end
    else
      MessageDlg('Ya existe un programa con ese nombre.', mtInformation, [mbok], 0)
  end
  else
  begin
    MessageDlg('Debe introducir el nombre del programa.', mtInformation, [mbok], 0);
    txtNombre.SetFocus;
  end;
end;

procedure TformAplicacionesDatosSensibles.bMarcarClick(Sender: TObject);
var
  i : integer;
begin
  for i := 0 to lAplicaciones.Count - 1 do
    lAplicaciones.Checked[i] := true;
end;

procedure TformAplicacionesDatosSensibles.bDesmarcarClick(Sender: TObject);
var
  i : integer;
begin
  for i := 0 to lAplicaciones.Count - 1 do
    lAplicaciones.Checked[i] := false;
end;

procedure TformAplicacionesDatosSensibles.bInvertirClick(Sender: TObject);
var
  i : integer;
begin
  for i := 0 to lAplicaciones.Count - 1 do
    lAplicaciones.Checked[i] := not lAplicaciones.Checked[i];
end;

end.
