unit UnidadCambiarIdentificadorPuesto;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, KDaoDataBase, DB, KDaoTable;

type
  TformCambiarIdentificadorPuesto = class(TForm)
    txtPuestoActual: TComboBox;
    Label1: TLabel;
    txtIdentificativoNuevo: TEdit;
    Label2: TLabel;
    bCambiar: TButton;
    Tabla: TKADaoTable;
    bCerrar: TButton;
    Panel1: TPanel;
    procedure bCambiarClick(Sender: TObject);
    procedure actualizarTabla (nombreTabla, dato, datoAnterior : string);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure llenarLista ();
    procedure bCerrarClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formCambiarIdentificadorPuesto: TformCambiarIdentificadorPuesto;

implementation

uses UnidadMenuPrincipal;

{$R *.dfm}

procedure TformCambiarIdentificadorPuesto.llenarLista ();
begin
 // DBD.Close;
 // DBD.Database := formMenuPrincipal.leCadenaINI ('Base de datos', 'Ruta y MDB', '');
 // DBD.Open;
  Tabla.Close;
  Tabla.SQL.Add('SELECT RedNombrePC FROM puesto');
  Tabla.Open;
  while not Tabla.Eof do
  begin
    txtPuestoActual.Items.Add(Tabla.fieldbyname('RedNombrePC').AsString);
    Tabla.Next;
  end;
  Tabla.Close;
end;

procedure TformCambiarIdentificadorPuesto.actualizarTabla (nombreTabla, dato, datoAnterior : string);
begin
  Tabla.Close;
  Tabla.sql.Clear;
  Tabla.sql.add ('UPDATE ' + nombreTabla + ' SET RedNombrePC = :pDato WHERE RedNombrePC = :pNombre');
  Tabla.Params.ParamByName('pDato').DataType := ftstring;
  Tabla.Params.ParamByName('pDato').Value := dato;
  Tabla.Params.ParamByName('pNombre').DataType := ftstring;
  Tabla.Params.ParamByName('pNombre').Value := datoAnterior;
  Tabla.ExecuteSQL;
//  Tabla.ExecSQL (Tabla.SQL);
end;

procedure TformCambiarIdentificadorPuesto.bCambiarClick(Sender: TObject);
begin
  //DBD.Close;
  //DBD.Database := formMenuPrincipal.leCadenaINI ('Base de datos', 'Ruta y MDB', '');
  //DBD.Open;
  Tabla.Close;
  Tabla.TableName := 'puesto';
  Tabla.Open;
  if Tabla.Locate('RedNombrePC', txtPuestoActual.Text, []) then
  begin
    Tabla.Edit;
    Tabla.FieldByName('RedNombrePC').Value := txtIdentificativoNuevo.Text;
    try
      Tabla.Post;
      MessageDlg('El identificativo ' + txtPuestoActual.Text +
          ' ha sido cambiado correctamente por ' +
          txtIdentificativoNuevo.Text, mtInformation, [mbok], 0);
      txtPuestoActual.Text := '';
      txtIdentificativoNuevo.Text := '';
      txtPuestoActual.Clear;
      llenarLista;
      txtPuestoActual.SetFocus;
    except
      raise
    end;
    //actualizarTabla ('software', txtIdentificativoNuevo.Text, txtPuestoActual.Text);
  end;
end;

procedure TformCambiarIdentificadorPuesto.FormCreate(Sender: TObject);
begin
  txtPuestoActual.Items.Clear;
  llenarLista ();
end;

procedure TformCambiarIdentificadorPuesto.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Tabla.Close;
//  DBD.Close;
  Action := caFree;
end;

procedure TformCambiarIdentificadorPuesto.bCerrarClick(Sender: TObject);
begin
  close;
end;

end.
