unit UnidadCarpetas;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, KDaoDataBase, DB, KDaoTable, ComCtrls, DBCtrls, ExtCtrls, Grids,
  DBGrids, StdCtrls, Mask, Buttons, ActnList;

type
  TformCarpetas = class(TForm)
    Tabla: TKADaoTable;
    DBD: TKADaoDatabase;
    PageControl1: TPageControl;
    tabEditar: TTabSheet;
    tabLista: TTabSheet;
    DBGrid1: TDBGrid;
    Panel1: TPanel;
    DBNavigator2: TDBNavigator;
    dTabla: TDataSource;
    Label1: TLabel;
    txtPuesto: TDBComboBox;
    tConsultaCS: TKADaoTable;
    Label12: TLabel;
    TablaRuta: TStringField;
    TablaRedNombrePC: TStringField;
    Label2: TLabel;
    txtNombrePCRed: TDBEdit;
    Label3: TLabel;
    txtRuta: TDBEdit;
    tablaPermisos: TDBGrid;
    tPermisosCarpetas: TKADaoTable;
    dPermisosCarpetas: TDataSource;
    bGuardarCarpeta: TBitBtn;
    TablaId: TAutoIncField;
    txtRecursoCompartido: TDBEdit;
    Label4: TLabel;
    TablaNombreCarpetaRed: TStringField;
    TablaNombrePCRed: TStringField;
    tPermisosCarpetasIdCarpeta: TIntegerField;
    tPermisosCarpetasGrupo: TStringField;
    tPermisosCarpetasUsuario: TStringField;
    tPermisosCarpetasPermiso: TStringField;
    tUsuarios: TKADaoTable;
    tPermisosCarpetasLUsuario: TStringField;
    tGrupos: TKADaoTable;
    tPermisosCarpetasLGrupo: TStringField;
    bNuevoUsuario: TButton;
    bNuevoGrupo: TButton;
    lInfCRed: TLabel;
    ActionList1: TActionList;
    Action1: TAction;
    bComprobar: TBitBtn;
    bComprobarRec: TBitBtn;
    DBNavigator1: TDBNavigator;
    Panel2: TPanel;
    lBuscar: TLabel;
    txtBNombre: TEdit;
    bBuscarN: TButton;
    Button1: TButton;
    opPuesto: TRadioButton;
    opRecCompartido: TRadioButton;
    opPuestoRed: TRadioButton;
    opRutaFisica: TRadioButton;
    procedure DBEdit7KeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure TablaBeforeInsert(DataSet: TDataSet);
    procedure llenarLista ();

    function existeCarpetaRed (carpeta : string) : boolean;
    procedure txtHoraFinExit(Sender: TObject);
    procedure bGuardarCarpetaClick(Sender: TObject);
    procedure tPermisosCarpetasBeforePost(DataSet: TDataSet);
    procedure tPermisosCarpetasAfterInsert(DataSet: TDataSet);
    function obtenerNombrePCRed (puesto : string) : string;
    procedure bNuevoGrupoClick(Sender: TObject);
    procedure bNuevoUsuarioClick(Sender: TObject);
    procedure txtPuestoClick(Sender: TObject);
    procedure txtPuestoExit(Sender: TObject);
    procedure txtRecursoCompartidoExit(Sender: TObject);
    procedure tPermisosCarpetasBeforeInsert(DataSet: TDataSet);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure DBGrid1DblClick(Sender: TObject);
    procedure txtRutaKeyPress(Sender: TObject; var Key: Char);
    procedure TablaAfterInsert(DataSet: TDataSet);
    procedure Action1Execute(Sender: TObject);
    procedure bComprobarClick(Sender: TObject);
    procedure bComprobarRecClick(Sender: TObject);
    procedure bBuscarNClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure opPuestoClick(Sender: TObject);
    procedure txtBNombreKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
    unidadFisica : string;
  public
    { Public declarations }
  end;

var
  formCarpetas: TformCarpetas;

implementation

uses UnidadMenuPrincipal;

{$R *.dfm}

function TformCarpetas.obtenerNombrePCRed (puesto : string) : string;
begin
  Result := '';
  if Tabla.State in [dsedit, dsinsert] then
  begin
    tConsultaCS.Close;
    tConsultaCS.SQL.Clear;
    tConsultaCS.SQL.Add('SELECT RedNombrePCValido FROM puesto WHERE format(rednombrepc, ">") = :pNombre');
    tConsultaCS.Params.ParamByName('pNombre').DataType := ftString;
    tConsultaCS.Params.ParamByName('pNombre').Value := AnsiUpperCase (puesto);
    tConsultaCS.Open;
    Result := tConsultaCS.FieldByName('rednombrepcvalido').AsString;
    tConsultaCS.Close;
  end;
end;

function TformCarpetas.existeCarpetaRed (carpeta : string) : boolean;
begin
  tConsultaCS.Close;
  tConsultaCS.SQL.Clear;
  tConsultaCS.SQL.Add('SELECT NombreCarpetaRed FROM CarpetasCompartidas WHERE NombreCarpetaRed = :pNombre');
  tConsultaCS.Params.ParamByName('pNombre').DataType := ftString;
  tConsultaCS.Params.ParamByName('pNombre').Value := carpeta;
  tConsultaCS.Open;
  result := tConsultaCS.recordcount > 0;
  tConsultaCS.Close;
end;

procedure TformCarpetas.llenarLista ();
begin
//  DBD.Close;
//  DBD.Database := formMenuPrincipal.leCadenaINI ('Base de datos', 'Ruta y MDB', '');
//  DBD.Open;
  tConsultaCS.Close;
  tConsultaCS.SQL.Add('SELECT RedNombrePC FROM puesto');
  tConsultaCS.Open;
  txtPuesto.Clear;
  while not tConsultaCS.Eof do
  begin
    txtPuesto.Items.Add(tConsultaCS.fieldbyname('RedNombrePC').AsString);
    tConsultaCS.Next;
  end;
end;


procedure TformCarpetas.DBEdit7KeyPress(Sender: TObject;
  var Key: Char);
begin
  if Key = '.' then
    Key := ',';
end;

procedure TformCarpetas.FormCreate(Sender: TObject);
begin
//  DBD.Close;
//  DBD.Database := formMenuPrincipal.leCadenaINI ('Base de datos', 'Ruta y MDB', '');
//  DBD.Open;
  llenarLista;
  tUsuarios.Open;
  tGrupos.Open;
  Tabla.Open;
  tPermisosCarpetas.Open;
  unidadFisica := formMenuPrincipal.leCadenaINI ('Defecto',
      'Carpetas compartidas - Ruta unidad fsica', 'C:\');
  tabLista.Show;
end;

procedure TformCarpetas.TablaBeforeInsert(DataSet: TDataSet);
begin
  tabEditar.Show;
  txtRecursoCompartido.SetFocus;
end;

procedure TformCarpetas.txtHoraFinExit(Sender: TObject);
begin
//  Tabladuracion.Value := inttostr(datetoint (Tablahorafin.Value) - datetoint(Tablahorainicio.Value));
end;

procedure TformCarpetas.bGuardarCarpetaClick(Sender: TObject);
begin
  if Tabla.State in [dsedit, dsinsert] then
  begin
    Tabla.Post;
    tablaPermisos.SetFocus;
    tPermisosCarpetas.Insert;
    tPermisosCarpetasGrupo.Value := 'Administradores';
    tPermisosCarpetasPermiso.Value := 'Escritura';
    tPermisosCarpetas.Post;
    tPermisosCarpetas.Insert;
  end;
end;

procedure TformCarpetas.tPermisosCarpetasBeforePost(DataSet: TDataSet);
begin
  if (tPermisosCarpetasUsuario.AsString = '') and
      (tPermisosCarpetasGrupo.AsString = '') then
    MessageDlg('Debe especificar un Usuario o Grupo de seguridad.',
        mtInformation, [mbok], 0);
end;

procedure TformCarpetas.tPermisosCarpetasAfterInsert(DataSet: TDataSet);
begin
  tPermisosCarpetasPermiso.Value := 'Escritura';
end;

procedure TformCarpetas.bNuevoGrupoClick(Sender: TObject);
begin
  formMenuPrincipal.actGruposSeguridadExecute(Self);
  tGrupos.Refresh;
end;

procedure TformCarpetas.bNuevoUsuarioClick(Sender: TObject);
begin
  formMenuPrincipal.actNuevoUsuarioExecute(Self);
  tUsuarios.Refresh;
end;

procedure TformCarpetas.txtPuestoClick(Sender: TObject);
begin
  if Tabla.State in [dsedit, dsinsert] then
  begin
    if TablaRedNombrePC.AsString <> '' then
    begin
      TablaNombrePCRed.Value := obtenerNombrePCRed (txtPuesto.Text);
      if TablaNombrePCRed.Value <> '' then
        txtRecursoCompartido.SetFocus;
    end;
  end;
end;

procedure TformCarpetas.txtPuestoExit(Sender: TObject);
begin
  if Tabla.State in [dsedit, dsinsert] then
  begin
    if TablaRedNombrePC.AsString <> '' then
    begin
      TablaNombrePCRed.Value := obtenerNombrePCRed (txtPuesto.Text);
      if TablaNombrePCRed.Value <> '' then
        txtRecursoCompartido.SetFocus;
    end;
  end;
end;

procedure TformCarpetas.txtRecursoCompartidoExit(Sender: TObject);
begin
  if Tabla.State in [dsedit, dsinsert] then
  begin
    if TablaRuta.AsString = '' then
    begin
      TablaRuta.Value :=   unidadFisica + TablaNombreCarpetaRed.AsString;
      if existeCarpetaRed(TablaNombreCarpetaRed.AsString) then
      begin
        lInfCRed.Font.Color := clRed;
        lInfCRed.Caption := '<< Este recurso compartido ya existe';
      end
      else
        lInfCRed.Caption := '';
    end
    else
      
  end;
end;

procedure TformCarpetas.tPermisosCarpetasBeforeInsert(DataSet: TDataSet);
begin
  if Tabla.State in [dsedit, dsinsert] then
    Tabla.Post;
end;

procedure TformCarpetas.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  if tPermisosCarpetas.State in [dsedit, dsinsert] then
    tPermisosCarpetas.Post;
end;

procedure TformCarpetas.DBGrid1DblClick(Sender: TObject);
begin
  tabEditar.Show;
end;

procedure TformCarpetas.txtRutaKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
    bGuardarCarpeta.SetFocus;
end;

procedure TformCarpetas.TablaAfterInsert(DataSet: TDataSet);
begin
  TablaNombrePCRed.Value := 'PASCAL';
  TablaRedNombrePC.Value := 'PASCAL';
end;

procedure TformCarpetas.Action1Execute(Sender: TObject);
begin
Tabla.Insert;
end;

procedure TformCarpetas.bComprobarClick(Sender: TObject);
begin
  if DirectoryExists(txtRuta.Text) then
    MessageDlg('La carpeta: ' + chr(13) + chr(13) + txtRuta.Text +
        chr(13) + chr(13) + 'Existe en este equipo.',
        mtInformation, [mbok], 0)
  else
    MessageDlg('La carpeta: ' + chr(13) + chr(13) + txtRuta.Text +
        chr(13) + chr(13) + 'No existe en este equipo.',
        mtWarning, [mbok], 0);
end;

procedure TformCarpetas.bComprobarRecClick(Sender: TObject);
var
  ruta : string;
begin
  ruta := '\\' + txtNombrePCRed.Text + '\' + txtRecursoCompartido.Text; 
  if DirectoryExists(ruta) then
  begin
    lInfCRed.Caption := ruta + ' >> existe en: ' + txtNombrePCRed.Text;
    lInfCRed.Font.Color := clGreen;
  end
  else
  begin
    lInfCRed.Caption := ruta + ' >> no existe en: ' + txtNombrePCRed.Text;
    lInfCRed.Font.Color := clRed;
  end;
end;

procedure TformCarpetas.bBuscarNClick(Sender: TObject);
begin
  tabla.Close;
  tabla.SQL.Clear;
  if opRecCompartido.Checked then
    tabla.SQL.Add('SELECT * FROM CarpetasCompartidas WHERE NombreCarpetaRed like :pDato');
  if opPuesto.Checked then
    tabla.SQL.Add('SELECT * FROM CarpetasCompartidas WHERE NombrePCRed like :pDato');
  if opPuestoRed.Checked then
    tabla.SQL.Add('SELECT * FROM CarpetasCompartidas WHERE RedNombrePC like :pDato');
  if opRutaFisica.Checked then
    tabla.SQL.Add('SELECT * FROM CarpetasCompartidas WHERE Ruta like :pDato');
  tabla.params.ParamByName ('pDato').DataType := ftString;
  tabla.params.ParamByName ('pDato').Value := '*' + txtBNombre.Text + '*';
  tabla.Open;
end;

procedure TformCarpetas.Button1Click(Sender: TObject);
begin
  tabla.Close;
  tabla.SQL.Clear;
  tabla.SQL.Add('SELECT * FROM CarpetasCompartidas');
  tabla.Open;
end;

procedure TformCarpetas.opPuestoClick(Sender: TObject);
begin
  if opRecCompartido.Checked then
    lBuscar.Caption := 'Buscar por Rec. Compart.:';
  if opRutaFisica.Checked then
    lBuscar.Caption := 'Buscar por Ruta fsica:';
  if opPuesto.Checked then
    lBuscar.Caption := 'Buscar por Puesto:';
  if opPuestoRed.Checked then
    lBuscar.Caption := 'Buscar por Nombre PC Red:';
end;

procedure TformCarpetas.txtBNombreKeyPress(Sender: TObject; var Key: Char);
begin
  if key = #13 then
    bBuscarN.SetFocus;
end;

end.
