unit UnidadEliminarPuesto;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, KDaoDataBase, DB, KDaoTable;

type
  TformEliminarPuesto = class(TForm)
    txtPuestoActual: TComboBox;
    Label1: TLabel;
    bEliminar: TButton;
    Tabla: TKADaoTable;
    opEliminarUsuario: TCheckBox;
    bCerrar: TButton;
    Panel1: TPanel;
    procedure bEliminarClick(Sender: TObject);
    procedure actualizarTabla (nombreTabla, dato, datoAnterior : string);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure llenarLista ();
    procedure bCerrarClick(Sender: TObject);
    procedure txtPuestoActualKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formEliminarPuesto: TformEliminarPuesto;

implementation

uses UnidadMenuPrincipal;

{$R *.dfm}

procedure TformEliminarPuesto.llenarLista ();
begin
 // DBD.Close;
 // DBD.Database := formMenuPrincipal.leCadenaINI ('Base de datos', 'Ruta y MDB', '');
 // DBD.Open;
  Tabla.Close;
  Tabla.SQL.Add('SELECT RedNombrePC FROM puesto');
  Tabla.Open;
  while not Tabla.Eof do
  begin
    txtPuestoActual.Items.Add(Tabla.fieldbyname('RedNombrePC').AsString);
    Tabla.Next;
  end;
  Tabla.Close;
end;

procedure TformEliminarPuesto.actualizarTabla (nombreTabla, dato, datoAnterior : string);
begin
  Tabla.Close;
  Tabla.sql.Clear;
  Tabla.sql.add ('UPDATE ' + nombreTabla + ' SET RedNombrePC = :pDato WHERE RedNombrePC = :pNombre');
  Tabla.Params.ParamByName('pDato').DataType := ftstring;
  Tabla.Params.ParamByName('pDato').Value := dato;
  Tabla.Params.ParamByName('pNombre').DataType := ftstring;
  Tabla.Params.ParamByName('pNombre').Value := datoAnterior;
  Tabla.ExecuteSQL;
//  Tabla.ExecSQL (Tabla.SQL);
end;

procedure TformEliminarPuesto.bEliminarClick(Sender: TObject);
var
  usuario : string;
begin
  //DBD.Close;
  //DBD.Database := formMenuPrincipal.leCadenaINI ('Base de datos', 'Ruta y MDB', '');
  //DBD.Open;
  Tabla.Close;
  Tabla.TableName := 'puesto';
  Tabla.Open;
  if Tabla.Locate('RedNombrePC', txtPuestoActual.Text, []) then
  begin
    try
      if MessageDlg('Se va a eliminar definitivamente el puesto ' +
          txtPuestoActual.Text + chr(13) + chr(13) +
          '   Usuario: ' + tabla.fieldbyname('UsuarioRed').AsString + chr(13) +
          '   Fecha de revisin: ' + tabla.fieldbyname('FechaRevision').AsString + chr(13) +
          '   Sistema operativo: ' + tabla.fieldbyname('SOPlataforma').AsString + chr(13) + chr(13) +
          'Desea eliminarlo definitivamente?',
          mtConfirmation, [mbyes, mbno], 0) = mryes then
      begin
        usuario := tabla.fieldbyname('UsuarioRed').AsString;
        Tabla.Delete;
        messageDlg ('El puesto ' + txtPuestoActual.Text +
           ' ha sido eliminado correctamente.',
            mtInformation, [mbok], 0);
        llenarLista;
      end;
      if opEliminarUsuario.Checked then
      begin
        Tabla.Close;
        Tabla.TableName := 'usuario';
        Tabla.Open;
        if Tabla.Locate('UsuarioRed', usuario, []) then
        begin
          if MessageDlg('Est seguro que desea eliminar el usuario ' +
              usuario + ': ' + tabla.fieldbyname('Nombre').AsString + '?',
              mtConfirmation, [mbyes, mbno], 0) = mryes then
            Tabla.Delete;
            messageDlg ('El usuario ' + usuario +
               ' ha sido eliminado correctamente.',
                mtInformation, [mbok], 0);
        end
        else
          messageDlg ('No se ha encontrado el usuario: ' + usuario,
              mtInformation, [mbok], 0);
      end;
      txtPuestoActual.SetFocus;
      Tabla.Close;
    except
      txtPuestoActual.SetFocus;
      raise;
    end;
  end
  else
  begin
    txtPuestoActual.SetFocus;
    messageDlg ('No se ha encontrado el puesto: ' + txtPuestoActual.text,
        mtInformation, [mbok], 0);
  end;
end;

procedure TformEliminarPuesto.FormCreate(Sender: TObject);
begin
  txtPuestoActual.Items.Clear;
  llenarLista ();
end;

procedure TformEliminarPuesto.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Tabla.Close;
//  DBD.Close;
  Action := caFree;
end;

procedure TformEliminarPuesto.bCerrarClick(Sender: TObject);
begin
  close;
end;

procedure TformEliminarPuesto.txtPuestoActualKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = #13 then
    bEliminar.SetFocus;
end;

end.
