unit UnidadEliminarUsuario;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, KDaoDataBase, DB, KDaoTable;

type
  TformEliminarUsuario = class(TForm)
    txtPuestoActual: TComboBox;
    Label1: TLabel;
    bEliminar: TButton;
    Tabla: TKADaoTable;
    opEliminarPuesto: TCheckBox;
    bCerrar: TButton;
    Panel1: TPanel;
    tc: TKADaoTable;
    procedure bEliminarClick(Sender: TObject);
    procedure actualizarTabla (nombreTabla, dato, datoAnterior : string);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure llenarLista ();
    procedure bCerrarClick(Sender: TObject);
    procedure txtPuestoActualKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formEliminarUsuario: TformEliminarUsuario;

implementation

uses UnidadMenuPrincipal;

{$R *.dfm}

procedure TformEliminarUsuario.llenarLista ();
begin
 // DBD.Close;
 // DBD.Database := formMenuPrincipal.leCadenaINI ('Base de datos', 'Ruta y MDB', '');
 // DBD.Open;
  Tabla.Close;
  Tabla.SQL.Add('SELECT usuarioRed FROM usuario');
  Tabla.Open;
  while not Tabla.Eof do
  begin
    txtPuestoActual.Items.Add(Tabla.fieldbyname('usuariored').AsString);
    Tabla.Next;
  end;
  Tabla.Close;
end;

procedure TformEliminarUsuario.actualizarTabla (nombreTabla, dato, datoAnterior : string);
begin
  Tabla.Close;
  Tabla.sql.Clear;
  Tabla.sql.add ('UPDATE ' + nombreTabla + ' SET RedNombrePC = :pDato WHERE RedNombrePC = :pNombre');
  Tabla.Params.ParamByName('pDato').DataType := ftstring;
  Tabla.Params.ParamByName('pDato').Value := dato;
  Tabla.Params.ParamByName('pNombre').DataType := ftstring;
  Tabla.Params.ParamByName('pNombre').Value := datoAnterior;
  Tabla.ExecuteSQL;
//  Tabla.ExecSQL (Tabla.SQL);
end;

procedure TformEliminarUsuario.bEliminarClick(Sender: TObject);
var
  pcAsignado, texto : string;
begin
  //DBD.Close;
  //DBD.Database := formMenuPrincipal.leCadenaINI ('Base de datos', 'Ruta y MDB', '');
  //DBD.Open;
  Tabla.Close;
  Tabla.TableName := 'usuario';
  Tabla.Open;
  if Tabla.Locate('UsuarioRed', txtPuestoActual.Text, []) then
  begin
    tc.Close;
    tc.SQL.Clear;
    tc.SQL.Add('select *');
    tc.SQL.Add('from puesto');
    tc.SQL.Add('where usuariored = "' + txtPuestoActual.Text + '"');
    tc.Open;
    if tc.RecordCount > 0 then
      pcAsignado := tc.fieldbyname ('RedNombrePC').asstring
    else
      pcAsignado := '';
    try
      if pcAsignado = '' then
        texto := 'Se va a eliminar definitivamente el usuario ' +
            txtPuestoActual.Text + chr(13) + chr(13) +
            '   Nombre: ' + tabla.fieldbyname('Nombre').AsString + chr(13) +
            '   Departamento: ' + tabla.fieldbyname('Departamento').AsString + chr(13) +
            '   Fecha alta: ' + tabla.fieldbyname('FechaAlta').AsString + chr(13) +
            '   Asignado a Puesto: ******* SIN ASIGNAR *******' + chr(13) + chr(13) +
            'Desea eliminarlo definitivamente?'
      else
        texto := 'Se va a eliminar definitivamente el usuario ' +
            txtPuestoActual.Text + chr(13) + chr(13) +
            '   Nombre: ' + tabla.fieldbyname('Nombre').AsString + chr(13) +
            '   Departamento: ' + tabla.fieldbyname('Departamento').AsString + chr(13) +
            '   Fecha alta: ' + tabla.fieldbyname('FechaAlta').AsString + chr(13) +
            '   Asignado a Puesto: ' + pcAsignado + chr(13) + chr(13) +
            'Desea eliminarlo definitivamente?';
      if MessageDlg(texto, mtConfirmation, [mbyes, mbno], 0) = mryes then
      begin
        Tabla.Delete;
        messageDlg ('El usuario ' + txtPuestoActual.Text +
           ' ha sido eliminado correctamente.',
            mtInformation, [mbok], 0);
        llenarLista;
      end;
      if opEliminarPuesto.Checked and (pcAsignado <> '') then
      begin
        Tabla.Close;
        Tabla.TableName := 'puesto';
        Tabla.Open;
        if Tabla.Locate('RedNombrePC', pcAsignado, []) then
        begin
          if MessageDlg('Est seguro que desea eliminar el puesto ' +
              pcAsignado + ': ' + tabla.fieldbyname('RedNombrePCValido').AsString + '?',
              mtConfirmation, [mbyes, mbno], 0) = mryes then
            Tabla.Delete;
            messageDlg ('El puesto ' + pcAsignado +
               ' ha sido eliminado correctamente.',
                mtInformation, [mbok], 0);
        end;
      end;
      txtPuestoActual.SetFocus;
      Tabla.Close;
    except
      txtPuestoActual.SetFocus;
      raise;
    end;
  end
  else
  begin
    txtPuestoActual.SetFocus;
    messageDlg ('No se ha encontrado el usuario: ' + txtPuestoActual.text,
        mtInformation, [mbok], 0);
  end;
end;

procedure TformEliminarUsuario.FormCreate(Sender: TObject);
begin
  txtPuestoActual.Items.Clear;
  llenarLista ();
end;

procedure TformEliminarUsuario.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Tabla.Close;
//  DBD.Close;
  Action := caFree;
end;

procedure TformEliminarUsuario.bCerrarClick(Sender: TObject);
begin
  close;
end;

procedure TformEliminarUsuario.txtPuestoActualKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = #13 then
    bEliminar.SetFocus;
end;

end.
