unit UnidadNuevoAviso;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, DB, KDaoTable;

type
  TformNuevoAviso = class(TForm)
    txtValorComprobar: TEdit;
    Label1: TLabel;
    lAviso: TLabel;
    txtAviso: TEdit;
    txtEn: TComboBox;
    Label3: TLabel;
    txtOperador: TComboBox;
    Label4: TLabel;
    Button1: TButton;
    opEnviarPorEMail: TCheckBox;
    opMostrarAviso: TCheckBox;
    txtEMailEnvio: TEdit;
    lEmail: TLabel;
    tAvisos: TKADaoTable;
    tAvisosEnValorObtenido: TStringField;
    tAvisosOperador: TStringField;
    tAvisosValorAComprobar: TStringField;
    tAvisosTextoAvisoMostrar: TStringField;
    tAvisosCritico: TBooleanField;
    tAvisosMostrarAviso: TBooleanField;
    tAvisosAlmacenarAvisoBD: TBooleanField;
    tAvisosEnviarPorEMail: TBooleanField;
    tAvisosEMailEnvio: TStringField;
    opCritico: TCheckBox;
    bCancelar: TButton;
    bSeleccionarFichero: TButton;
    dgAbrir: TOpenDialog;
    procedure Button1Click(Sender: TObject);
    procedure opMostrarAvisoClick(Sender: TObject);
    procedure bCancelarClick(Sender: TObject);
    procedure txtEnChange(Sender: TObject);
    procedure llenarOperador ();
    procedure bSeleccionarFicheroClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formNuevoAviso: TformNuevoAviso;

implementation

uses UnidadOpciones;

{$R *.dfm}

procedure TformNuevoAviso.llenarOperador ();
begin
  txtOperador.Clear;
  txtValorComprobar.Width := 292;
  bSeleccionarFichero.Visible := false;
  if txtEn.Text = 'Programas instalados' then
  begin
    txtOperador.Items.Add ('Igual');
    txtOperador.Items.Add ('Distinto');
  end;
  if txtEn.Text = 'Memoria RAM total' then
  begin
    txtOperador.Items.Add ('Igual');
    txtOperador.Items.Add ('Distinto');
    txtOperador.Items.Add ('Mayor');
    txtOperador.Items.Add ('Menor');
    txtOperador.Items.Add ('Menor o Igual');
    txtOperador.Items.Add ('Mayor o Igual');
  end;
  if txtEn.Text = 'Memoria RAM libre' then
  begin
    txtOperador.Items.Add ('Igual');
    txtOperador.Items.Add ('Distinto');
    txtOperador.Items.Add ('Mayor');
    txtOperador.Items.Add ('Menor');
    txtOperador.Items.Add ('Menor o Igual');
    txtOperador.Items.Add ('Mayor o Igual');
  end;
  if txtEn.Text = 'Clave S.O.' then
  begin
    txtOperador.Items.Add ('Igual');
    txtOperador.Items.Add ('Distinto');
  end;
  if txtEn.Text = 'Proceso activo' then
  begin
    txtOperador.Items.Add ('Igual');
    txtOperador.Items.Add ('Distinto');
  end;
  if txtEn.Text = 'Buscar fichero' then
  begin
    txtOperador.Items.Add ('Existe');
    txtOperador.Items.Add ('Existe -> Ser eliminado');    
    txtOperador.Items.Add ('No existe');
    txtValorComprobar.Width := 268;
    bSeleccionarFichero.Visible := true;
  end;
  if txtEn.Text = 'Idioma del teclado' then
  begin
    txtOperador.Items.Add ('Igual');
    txtOperador.Items.Add ('Distinto');
  end;                               
end;

procedure TformNuevoAviso.Button1Click(Sender: TObject);
var
  faltanDatos : boolean;
begin
  faltanDatos := false;
  if txtEn.Text = '' then
    faltanDatos := true;
  if txtOperador.Text = '' then
    faltanDatos := true;
  if txtValorComprobar.Text = '' then
    faltanDatos := true;
  if not faltanDatos then
  begin
    tAvisos.Open;
    if not tAvisos.Locate('ValorAComprobar;Operador;EnValorObtenido',
        varArrayOf([txtValorComprobar.Text,txtOperador.text,
        txtEn.text]), []) then
    begin
      tAvisos.Insert;
      tAvisosEnValorObtenido.Value := txtEn.Text;
      tAvisosOperador.Value := txtOperador.Text;
      tAvisosValorAComprobar.Value := txtValorComprobar.Text;
      tAvisosMostrarAviso.Value := opMostrarAviso.Checked;
      tAvisosTextoAvisoMostrar.Value := txtAviso.Text;
      //tAvisosAlmacenarAvisoBD.Value := opAlmacenarAviso.Checked;
      tAvisosEnviarPorEMail.Value := opEnviarPorEMail.Checked;
      tAvisosEMailEnvio.Value := txtEMailEnvio.Text;
      tAvisosCritico.Value := opCritico.Checked;
      tAvisos.Post;
    end
    else
      MessageDlg('Ya existe un aviso con estas caractersticas.', mtWarning, [mbok], 0);
    close;
  end
  else
    MessageDlg ('Faltan datos por introducir.', mtWarning, [mbok], 0); 
end;

procedure TformNuevoAviso.opMostrarAvisoClick(Sender: TObject);
begin
  txtAviso.Visible := opMostrarAviso.Checked;
  lAviso.Visible := opMostrarAviso.Checked;
end;

procedure TformNuevoAviso.bCancelarClick(Sender: TObject);
begin
  Close;
end;

procedure TformNuevoAviso.txtEnChange(Sender: TObject);
begin
  llenarOperador ();
end;

procedure TformNuevoAviso.bSeleccionarFicheroClick(Sender: TObject);
begin
  dgAbrir.Title := 'Seleccione fichero para aviso...';
  dgAbrir.Filter := 'Todos los archivos (*.*)|*.*';
  if dgAbrir.Execute then
    txtValorComprobar.Text := dgAbrir.FileName;
end;

end.
