unit UnidadReglasSeguridad;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, KDaoDataBase, KDaoTable, DB, DBTables,
  ComCtrls;

type
  TformReglasSeguridad = class(TForm)
    GroupBox5: TGroupBox;
    Label2: TLabel;
    Label3: TLabel;
    Label6: TLabel;
    txtTipo: TComboBox;
    txtPC: TComboBox;
    txtNombre: TComboBox;
    Query1: TQuery;
    Tabla: TKADaoTable;
    DBD: TKADaoDatabase;
    txtDispositivo: TComboBox;
    Label1: TLabel;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    GroupBox2: TGroupBox;
    Panel3: TPanel;
    txtRegla: TMemo;
    GroupBox1: TGroupBox;
    Panel2: TPanel;
    txtUsuarios: TMemo;
    GroupBox14: TGroupBox;
    txtObservacion: TMemo;
    Panel4: TPanel;
    GroupBox3: TGroupBox;
    txtNATOrigen: TEdit;
    Label4: TLabel;
    txtNATDestino: TEdit;
    Label5: TLabel;
    Edit1: TEdit;
    Label7: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure bInsertarClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formReglasSeguridad: TformReglasSeguridad;

implementation

uses UnidadMenuPrincipal;

{$R *.dfm}

procedure TformReglasSeguridad.FormCreate(Sender: TObject);
begin
//  DBD.Close;
//  DBD.Database := formMenuPrincipal.leCadenaINI ('Base de datos', 'Ruta y MDB', '');
//  DBD.Open;

  //si es una modificacin mostramos todos los dispositivos en el desplegable
  if Tag = 20 then
  begin

  end;

  //Puesto
  Tabla.Close;
  Tabla.SQL.Clear;
  Tabla.SQL.Add('SELECT RedNombrePC FROM Puesto WHERE RedNombrePC IS NOT NULL');
  Tabla.Open;
  txtPC.Clear;
  while not Tabla.Eof do
  begin
    txtPC.Items.Add(Tabla.fieldbyname('RedNombrePC').Value);
    tabla.Next;
  end;

  //Todas las Reglas
  Tabla.Close;
  Tabla.SQL.Clear;
  Tabla.SQL.Add('SELECT Nombre FROM ReglasSeguridad');
  Tabla.Open;
  txtNombre.Clear;
  while not Tabla.Eof do
  begin
    txtNombre.Items.Add(Tabla.fieldbyname('Nombre').Value);
    tabla.Next;
  end;

  //Tipo dispositivo
  Tabla.Close;
  Tabla.SQL.Clear;
  Tabla.SQL.Add('SELECT Nombre FROM TipoDispositivo WHERE Nombre IS NOT NULL');
  Tabla.Open;
  txtTipo.Clear;
  while not Tabla.Eof do
  begin
    txtTipo.Items.Add(Tabla.fieldbyname('Nombre').Value);
    tabla.Next;
  end;
end;

procedure TformReglasSeguridad.bInsertarClick(Sender: TObject);
var
  nombre, tipo, dispositivo : string;
  insertar : boolean;
begin
  if txtNombre.Text = '' then
  begin
    MessageDlg('Debe introducir el nombre/descripcin de la regla de seguridad.',
        mtWarning, [mbok], 0);
    txtNombre.SetFocus;
  end
  else
  begin
    //comprobamos duplicidad
    Tabla.Close;
    Tabla.SQL.Clear;
    Tabla.SQL.Add('SELECT Nombre, Dispositivo, Tipo FROM ReglasSeguridad WHERE Nombre = :pNombre AND Dispositivo = :pDispositivo');
    Tabla.Params.ParamByName('pNombre').DataType := ftString;
    Tabla.Params.ParamByName('pNombre').Value := txtNombre.Text;
    Tabla.Params.ParamByName('pDispositivo').DataType := ftString;
    Tabla.Params.ParamByName('pDispositivo').Value := txtDispositivo.Text;
    Tabla.Open;
    if Tabla.RecordCount > 0 then
    begin
      if not varisnull(Tabla.fieldbyname('Nombre').value) then
        nombre := Tabla.fieldbyname('Nombre').value
      else
        nombre := '';
      if not varisnull(Tabla.fieldbyname('Dispositivo').value) then
        Dispositivo := Tabla.fieldbyname('Dispositivo').value
      else
        Dispositivo := '';
      if not varisnull(Tabla.fieldbyname('Tipo').value) then
        tipo := Tabla.fieldbyname('Tipo').value
      else
        tipo := '';

      insertar := MessageDlg('Atencin: ya existe una Regla con el mismo nombre: ' +
          chr(13) + chr(13) + 'Nombre: ' + nombre + chr(13) + 'Dispositivo: ' + dispositivo +
          chr(13) + 'Tipo: ' + tipo + chr(13) + 'Desea aadir esta regla?',
          mtWarning, [mbyes, mbno], 0) = mryes;
    end
    else
      insertar := true;
    if insertar then
    begin
      Tabla.Close;
      Tabla.SQL.Clear;
      Tabla.TableName := 'ReglasSeguridad';
      Tabla.Open;
      tabla.Insert;
      tabla.FieldByName('Nombre').Value := txtNombre.text;
      tabla.FieldByName('Tipo').Value := txtTipo.text;
      tabla.FieldByName('Dispositivo').Value := txtDispositivo.text;
      tabla.FieldByName('Descripcion').Value := txtObservacion.text;
      tabla.FieldByName('Fecha').Value := date;
      tabla.FieldByName('RedNombrePC').Value := txtPC.text;
      tabla.FieldByName('Regla').Value := txtRegla.text;
      tabla.FieldByName('Usuarios').Value := txtUsuarios.text;
     { tabla.FieldByName('OrigenOriginal').Value := txtPersonaContacto1.text;
      tabla.FieldByName('DestinoOriginal').Value := txtPersonaContacto2.text;
      tabla.FieldByName('ServicioOriginal').Value := txtTelefono1.text;
      tabla.FieldByName('OrigenTrasladado').Value := txtTelefono2.text;
      tabla.FieldByName('DestinioTrasladado').Value := txtFax1.text;
      tabla.FieldByName('ServicioTrasladado').Value := txtFax2.text;
      tabla.FieldByName('Numero').Value := txtEmail1.text;
      tabla.FieldByName('Origen').Value := txtEmail2.text;
      tabla.FieldByName('Destino').Value := txtweb1.text;
      tabla.FieldByName('VNP').Value := txtweb2.text;
      tabla.FieldByName('Servicio').Value := txtUso.text;
      tabla.FieldByName('Accion').Value := txtUso.text;
      tabla.FieldByName('Seguimiento').Value := txtUso.text;}
      Tabla.Post;
      if MessageDlg('La regla [' + txtNombre.Text + '] se ha aadido ' +
          'correctamente.  Desea aadir otra?',
          mtConfirmation, [mbyes, mbno], 0) = mryes then
      begin
        txtNombre.text := '';
        txtObservacion.text := '';
        txtRegla.text := '';
        txtUsuarios.text := '';
//        txtProveedor.text := '';
        txtNombre.SetFocus;
      end
      else
        close;
    end;
  end;
end;

end.
